/*
 * NAME
 *     ErrorLog.c -- error logging
 *
 * AUTHOR
 *     Ken MacLeod
 */

#ifndef lint
static char sccsId [] = "@(#) ErrorLog.c  1.1 11/7/90 09:55:10\n\t";
#endif

#include <sys/types.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include "ErrorLog.h"

char *errorNames[] = {
	"FATAL ERROR",		/* -3 */
	"ERROR",			/* -2 */
	"Warning",		/* -1 */
	"Level 0",
	"Level 1",
	"Level 2",
	"Level 3",
	"Level 4",
	"Level 5",
	"Level 6",
	"Level 7",
	"Level 8",
	"Level 9"
};

int debug;
extern char *programName;

ErrorLog (position, level, string)

char *position, *string;
int level;

{
	void exit ();
	time_t time (), theTime;
	char outString[1024], timeString[30];

	(void) time (&theTime);
	if (level <= debug) {
		(void) strcpy (timeString, ctime (&theTime));
		timeString[24] = '\0';
		(void) sprintf (outString, "%s [%s:%s] %s: %s\n", timeString, programName,
		    position, errorNames[level + 3], string);
		(void) fprintf (stderr, "%s", outString);
	}
	if (level == _fatalError)
		exit (1);
}
